<!---
Creator: Ed Tabara
Email: 1smartsolution@gmail.com
Date: 27 Nov 2008
Site: http://www.1smartsolution.com
Last update: 24 Dec 2009

Description: Mollom is a quality-assessment and spam-filtering service for user-submitted website content, including comments, contact form messages, and so on.

NOTE: Before using this component you will have to get an API Key from http://www.mollom.com
--->
<cfcomponent>
	<cffunction name="init" output="No" returntype="any" hint="initialize the component">
		<cfargument name="public_key" required="Yes" type="any">
		<cfargument name="secret_key" required="Yes" type="any">
		<cfset this.public_key = public_key>
		<cfset this.secret_key = secret_key>
		<cfreturn this>
	</cffunction>

	<cffunction name="HMAC_SHA1" returntype="string" access="private" output="No">
		<!--- I think Dmitry Yakhnov is the one who i need to thanks for this function --->
	   <cfargument name="signKey" type="string" required="true">
	   <cfargument name="signMessage" type="string" required="true">
	   <cfargument name="sFormat" type="string" required="false" default="iso-8859-1">

	   <cfset var jMsg = JavaCast("string", arguments.signMessage).getBytes(arguments.sFormat)>
	   <cfset var jKey = JavaCast("string", arguments.signKey).getBytes(arguments.sFormat)>

	   <cfset var key = createObject("java", "javax.crypto.spec.SecretKeySpec")>
	   <cfset var mac = createObject("java", "javax.crypto.Mac")>

	   <cfset key = key.init(jKey,"HmacSHA1")>

	   <cfset mac = mac.getInstance(key.getAlgorithm())>
	   <cfset mac.init(key)>
	   <cfset mac.update(jMsg)>

	   <cfreturn ToBase64(mac.doFinal())>
	</cffunction>

	<cffunction name="fault" returntype="any" access="private" output="No">
		<cfargument name="theXML" required="Yes" type="any">

		<cfset var rez = StructNew()>
		<cfset var rezNumb = ArrayLen(theXML.methodResponse.fault.value.struct.member)>
		<cfset var i = 0>

		<cfset rez.isError = 1>
		<cfloop index="i" from="1" to="#rezNumb#">
			<cfif StructKeyExists(theXML.methodResponse.fault.value.struct.member[i].value, "string")>
				<cfset rez[theXML.methodResponse.fault.value.struct.member[i].name.XmlText] = theXML.methodResponse.fault.value.struct.member[i].value.string.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.fault.value.struct.member[i].value, "int")>
				<cfset rez[theXML.methodResponse.fault.value.struct.member[i].name.XmlText] = theXML.methodResponse.fault.value.struct.member[i].value.int.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.fault.value.struct.member[i].value, "boolean")>
				<cfset rez[theXML.methodResponse.fault.value.struct.member[i].name.XmlText] = theXML.methodResponse.fault.value.struct.member[i].value.boolean.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.fault.value.struct.member[i].value, "double")>
				<cfset rez[theXML.methodResponse.fault.value.struct.member[i].name.XmlText] = theXML.methodResponse.fault.value.struct.member[i].value.double.XmlText>
			<cfelse>
				<cfset rez.message = cfhttp.FileContent>
			</cfif>
		</cfloop>
		<cfreturn rez>
	</cffunction>

	<cffunction name="getResults" returntype="any" access="private" output="No">
		<cfargument name="theXML" required="Yes" type="any">

		<cfset var rez = StructNew()>
		<cfset var rezNumb = ArrayLen(theXML.methodResponse.params.param.value.struct.member)>
		<cfset var i = 0>

		<cfset rez.isError = 0>
		<cfloop index="i" from="1" to="#rezNumb#">
			<cfif StructKeyExists(theXML.methodResponse.params.param.value.struct.member[i].value, "string")>
				<cfset rez[theXML.methodResponse.params.param.value.struct.member[i].name.XmlText] = theXML.methodResponse.params.param.value.struct.member[i].value.string.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.params.param.value.struct.member[i].value, "int")>
				<cfset rez[theXML.methodResponse.params.param.value.struct.member[i].name.XmlText] = theXML.methodResponse.params.param.value.struct.member[i].value.int.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.params.param.value.struct.member[i].value, "boolean")>
				<cfset rez[theXML.methodResponse.params.param.value.struct.member[i].name.XmlText] = theXML.methodResponse.params.param.value.struct.member[i].value.boolean.XmlText>
			<cfelseif StructKeyExists(theXML.methodResponse.params.param.value.struct.member[i].value, "double")>
				<cfset rez[theXML.methodResponse.params.param.value.struct.member[i].name.XmlText] = theXML.methodResponse.params.param.value.struct.member[i].value.double.XmlText>
			<cfelse>
				<cfset rez.isError = 1>
				<cfset rez.message = cfhttp.FileContent>
			</cfif>
		</cfloop>
		<cfreturn rez>
	</cffunction>
	
	<cffunction name="getServerList" output="No" returntype="any" hint="request a list of Mollom servers that can handle a site's calls">
		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var i = 0>
		<cfset var rezNumb = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.getServerList</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfhttp url="http://xmlrpc1.mollom.com/1.0" method="POST" useragent="1SmartSolution">
			<cfhttpparam type="XML" value="#theXML#">
		</cfhttp>
		
		<cfif IsXML(cfhttp.FileContent)>
			<cfset theXML = XMLParse(cfhttp.FileContent)>
			<cfif StructKeyExists(theXML.methodResponse, "fault")>
				<cfset rez = fault(theXML)>
			<cfelseif StructKeyExists(theXML.methodResponse.params.param.value, "array")>
				<cfset rez.isError = 0>
				<cfset rez.servers = ArrayNew(1)>
				<cfset rezNumb = ArrayLen(theXML.methodResponse.params.param.value.array.data.value)>
				<cfloop index="i" from="1" to="#rezNumb#">
					<cfset rez.servers[i] = theXML.methodResponse.params.param.value.array.data.value[i].string.XmlText>
				</cfloop>
			<cfelse>
				<cfset rez.isError = 1>
				<cfset rez.message = cfhttp.FileContent>
			</cfif>
		<cfelse>
			<cfset rez.isError = 1>
			<cfset rez.message = cfhttp.FileContent>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="checkContent" output="Yes" returntype="any" hint="It can be used to check if a comment is spam or not, and to get an assessment of its quality.">
		<!--- 
			Rezult:
			spam - Returns 1 if ham, 2 if spam and 3 if unsure
			quality - An assessment of the contents quality, between 0 and 1
			session_id - Session ID
		--->
		<cfargument name="session_id" default="" type="any"> <!--- current session id --->
		<cfargument name="post_title" default="" type="any"> <!--- Title of submitted post --->
		<cfargument name="post_body" default="" type="any"> <!--- Body of submitted post --->
		<cfargument name="author_name" default="" type="any"> <!--- Submitting user's name or nick --->
		<cfargument name="author_url" default="" type="any"> <!--- Submitting user's URL --->
		<cfargument name="author_mail" default="" type="any"> <!--- Submitting user's email address --->
		<cfargument name="author_openid" default="" type="any"> <!--- Submitting user's openID --->
		<cfargument name="author_ip" default="" type="any"> <!--- Submitting user's current IP --->
		<cfargument name="author_id" default="" type="any"> <!--- Submitting user's unique site ID --->

		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.checkContent</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<cfif Len(session_id)>
										<member>
											<name>session_id</name>
											<value><string>#session_id#</string></value>
										</member>
									</cfif>
									<cfif Len(post_title)>
										<member>
											<name>post_title</name>
											<value><string>#post_title#</string></value>
										</member>
									</cfif>
									<cfif Len(post_body)>
										<member>
											<name>post_body</name>
											<value><string><![CDATA[#post_body#]]></string></value>
										</member>
									</cfif>
									<cfif Len(author_name)>
										<member>
											<name>author_name</name>
											<value><string>#author_name#</string></value>
										</member>
									</cfif>
									<cfif Len(author_url)>
										<member>
											<name>author_url</name>
											<value><string>#author_url#</string></value>
										</member>
									</cfif>
									<cfif Len(author_mail)>
										<member>
											<name>author_mail</name>
											<value><string>#author_mail#</string></value>
										</member>
									</cfif>
									<cfif Len(author_openid)>
										<member>
											<name>author_openid</name>
											<value><string>#author_openid#</string></value>
										</member>
									</cfif>
									<cfif Len(author_ip)>
										<member>
											<name>author_ip</name>
											<value><string>#author_ip#</string></value>
										</member>
									</cfif>
									<cfif Len(author_id)>
										<member>
											<name>author_id</name>
											<value><string>#author_id#</string></value>
										</member>
									</cfif>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelseif StructKeyExists(theXML.methodResponse.params.param.value, "struct")>
							<cfset rez = getResults(theXML)>
							<cfset rez.isError = 0>
						<cfelse>
							<cfset rez.isError = 1>
							<cfset rez.message = cfhttp.FileContent>
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		<cfelse>
			<cfset rez.isError = 1>
			<cfset rez.message = mollomServers.message>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="sendFeedback" output="No" returntype="any" hint="It tells Mollom that the specified message was spam or otherwise inappropriate for the reporting website">
		<cfargument name="session_id" required="Yes" type="any"> <!--- Session ID associated with the feedback --->
		<cfargument name="feedback" required="Yes" type="any"> <!--- Feedback: spam, profanity, low-quality or unwanted --->

		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.sendFeedback</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<member>
										<name>session_id</name>
										<value><string>#session_id#</string></value>
									</member>
									<member>
										<name>feedback</name>
										<value><string>#feedback#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelse>
							<cfset rez.isError = 0>
							<cfset rez.message = "Yes">
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="verifyKey" output="No" returntype="any" hint="returns information about the status of a key">
		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.verifyKey</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelse>
							<cfset rez.isError = 0>
							<cfset rez.message = "Yes">
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="getStatistics" output="No" returntype="any" hint="retrieves usage statistics from Mollom">
		<cfargument name="type" required="Yes"> <!--- Type of statistics requested --->
		<!---
			There are several possible string values for type:
			total_days - Number of days Mollom has been used.
			total_accepted - Total accepted posts.
			total_rejected - Total rejected spam posts.
			yesterday_accepted - Number of posts accepted yesterday.
			yesterday_rejected - Number of spam posts blocked yesterday.
			today_accepted - Number of posts accepted today.
			today_rejected - Number of spam posts rejected today.
		--->
		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.getStatistics</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<member>
										<name>type</name>
										<value><string>#type#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelseif StructKeyExists(theXML.methodResponse, "params")>
							<cfset rez.isError = 0>
							<cfset rez.message = theXML.methodResponse.params.param.value.int.XmlText>
						<cfelse>
							<cfset rez.isError = 1>
							<cfset rez.message = cfhttp.FileContent>
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="getImageCaptcha" output="No" returntype="any" hint="generate an image CAPTCHA on the server-side">
		<cfargument name="session_id" required="Yes" type="any"> <!--- current Session ID --->
		<cfargument name="author_ip" required="Yes" type="any"> <!--- Submitting user's current IP address --->

		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.getImageCaptcha</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<member>
										<name>session_id</name>
										<value><string>#session_id#</string></value>
									</member>
									<member>
										<name>author_ip</name>
										<value><string>#author_ip#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelseif StructKeyExists(theXML.methodResponse.params.param.value, "struct")>
							<cfset rez = getResults(theXML)>
							<cfset rez.isError = 0>
						<cfelse>
							<cfset rez.isError = 1>
							<cfset rez.message = cfhttp.FileContent>
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="getAudioCaptcha" output="No" returntype="any" hint="generate an audio CAPTCHA on the server-side">
		<cfargument name="session_id" required="Yes" type="any"> <!--- current Session ID --->
		<cfargument name="author_ip" required="Yes" type="any"> <!--- Submitting user's current IP address --->

		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.getAudioCaptcha</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<member>
										<name>session_id</name>
										<value><string>#session_id#</string></value>
									</member>
									<member>
										<name>author_ip</name>
										<value><string>#author_ip#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelseif StructKeyExists(theXML.methodResponse.params.param.value, "struct")>
							<cfset rez = getResults(theXML)>
						<cfelse>
							<cfset rez.isError = 1>
							<cfset rez.message = cfhttp.FileContent>
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>

	<cffunction name="checkCaptcha" output="No" returntype="any" hint="validate a visitor's CAPTCHA answer">
		<cfargument name="session_id" required="Yes" type="any"> <!--- current Session ID --->
		<cfargument name="solution" required="Yes" type="any"> <!--- Submitted CAPTCHA solution --->

		<cfset var cfhttp = "">
		<cfset var theXML = "">
		<cfset var rez = StructNew()>
		<cfset var theTime = "#DateFormat(Now(), 'yyyy-mm-dd')#T#TimeFormat(Now(), 'HH:mm:ss')#.000+02000">
		<cfset var nonce = Hash(Now(), "MD5")>
		<cfset var hsh = HMAC_SHA1(this.secret_key, "#theTime#:#nonce#:#this.secret_key#")>
		<cfset var mollomServers = "">
		<cfset var bul = true>
		<cfset var currentServerIndex = 0>

		<cfoutput>
			<cfsavecontent variable="theXML"><?xml version="1.0"?>
				<methodCall>
				<methodName>mollom.checkCaptcha</methodName>
					<params>
						<param>
							<value>
								<struct>
									<member>
										<name>public_key</name>
										<value><string>#this.public_key#</string></value>
									</member>
									<member>
										<name>time</name>
										<value><string>#theTime#</string></value>
									</member>
									<member>
										<name>hash</name>
										<value><string>#hsh#</string></value>
									</member>
									<member>
										<name>nonce</name>
										<value><string>#nonce#</string></value>
									</member>
									<member>
										<name>session_id</name>
										<value><string>#session_id#</string></value>
									</member>
									<member>
										<name>solution</name>
										<value><string>#solution#</string></value>
									</member>
								</struct>
							</value>
						</param>
					</params>
				</methodCall>
			</cfsavecontent>
		</cfoutput>
		<cfset mollomServers = getServerList()>
		<cfif mollomServers.isError eq 0>
			<cfloop condition="bul">
				<cfset currentServerIndex = currentServerIndex + 1>
				<cfif ArrayLen(mollomServers.servers) gte currentServerIndex>
					<cfhttp url="#mollomServers.servers[currentServerIndex]#/1.0" method="POST" useragent="1SmartSolution">
						<cfhttpparam type="XML" value="#theXML#">
					</cfhttp>
					
					<cfif IsXML(cfhttp.FileContent)>
						<cfset theXML = XMLParse(cfhttp.FileContent)>
						<cfif StructKeyExists(theXML.methodResponse, "fault")>
							<cfset rez = fault(theXML)>
						<cfelseif StructKeyExists(theXML.methodResponse, "params")>
							<cfset rez.isError = 0>
							<cfset rez.message = YesNoFormat(theXML.methodResponse.params.param.value.boolean.XmlText)>
						</cfif>
					<cfelse>
						<cfset rez.isError = 1>
						<cfset rez.message = cfhttp.FileContent>
					</cfif>
				<cfelse>
					<cfset rez.isError = 1>
					<cfset rez.message = "All Mollom servers return error">
					<cfset bul = false>
				</cfif>
				<cfif rez.isError eq 0>
					<cfset bul = false>
				</cfif>
			</cfloop>
		</cfif>
		<cfreturn rez>
	</cffunction>
</cfcomponent>
